"
 COPYRIGHT (c) 1988 by Claus Gittinger
	      All Rights Reserved

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. The name of the above contributor may not be
    used to endorse or promote products derived from this software
    without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.
"
"{ Package: 'jv:calipel/s/benchmarks/stx' }"

Benchmark subclass:#BenchmarkSTX2
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-St/X'
!

!BenchmarkSTX2 class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1988 by Claus Gittinger
	      All Rights Reserved

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. The name of the above contributor may not be
    used to endorse or promote products derived from this software
    without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.
"
!

documentation
"
    some internal benchmarks (various primitive methods).
    These are not of public interest.
"
! !

!BenchmarkSTX2 class methodsFor:'helpers'!

noop0
    ^ 0
!

noop00
    ^ 0
!

noopINVALID:x
    x size > 100 ifTrue:[^ 999].

%{  /* UNLIMITEDSTACK */
    if (__isString(x)) {
	RETURN ( __MKSMALLINT(0) );
    }
%}.
    ^ 999
!

noopPR0
%{
    RETURN ( __MKSMALLINT(0) );
%}
!

noopPRNC0
%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(0) );
%}
!

noopPRSTK0
%{  /* STACK:10000 */
    RETURN ( __MKSMALLINT(0) );
%}
!

noopPRULSTK0
%{  /* UNLIMITEDSTACK */
    RETURN ( __MKSMALLINT(0) );
%}
! !

!BenchmarkSTX2 class methodsFor:'micro benchmarks'!

sendPoly
    "different primitive methods"

    |t a b|

    a := (1 to:1000) asArray.

    t := Time millisecondsToRun:[
	1000 timesRepeat:[
	    a do:[:el | el]
	].
    ].
    Transcript show:'empty loop: '; showCR:(t printString).

    t := Time millisecondsToRun:[
	1000 timesRepeat:[
	    a do:[:el | el negative]
	].
    ].
    Transcript show:'all int: '; showCR:(t printString).

    b := a collect:[:el | el asFloat].
    t := Time millisecondsToRun:[
	1000 timesRepeat:[
	    b do:[:el | el negative]
	].
    ].
    Transcript show:'all float: '; showCR:(t printString).

    b := a collect:[:el | el even ifTrue:[el asFloat] ifFalse:[el]].
    t := Time millisecondsToRun:[
	1000 timesRepeat:[
	    b do:[:el | el negative]
	].
    ].
    Transcript show:'alternating : '; showCR:(t printString).

    "
     STXBenchmarks2 sendPoly

	   Indy      486/50   P5/100            
cache      (none)     256k               
	   ----------------------------
empty        189       596     177
allInt      1006      2387     575
allFloat    1460      3139     827
altern'ng   2149      4942    1511
    "
!

sendPrim
    "different primitive methods"

    |t|

    t := Time millisecondsToRun:[
	1000000 timesRepeat:[
	    self noop0
	].
    ].
    Transcript show:'standard ^ 0: '; showCR:(t printString).

    t := Time millisecondsToRun:[
	1000000 timesRepeat:[
	    self noopPR0
	].
    ].
    Transcript show:'standard prim ret 0: '; showCR:(t printString).

    t := Time millisecondsToRun:[
	1000000 timesRepeat:[
	    self noopPRNC0
	].
    ].
    Transcript show:'no context prim ret 0: '; showCR:(t printString).

    t := Time millisecondsToRun:[
	1000000 timesRepeat:[
	    self noopPRSTK0
	].
    ].
    Transcript show:'stk prim ret 0: '; showCR:(t printString).

    t := Time millisecondsToRun:[
	1000000 timesRepeat:[
	    self noopPRULSTK0
	].
    ].
    Transcript show:'unl. stk prim ret 0: '; showCR:(t printString).

    "
     STXBenchmarks2 sendPrim

	Indy      486/50      P5/100        
cache   (none)     256k               
	----------------------------
std       386      1276         306
prim     1007      2316         495
no-stk    346      1151         304
stk      1007     11602(hit)   3695
ulstk    3584      7788        1812
    "
! !

