OPERATING_SYSTEM_NAME_XLATIONS =
  {
    /xp 5.1 i586/ => 'Windows XP (i386)',
    /Linux 3\..*i686/ => 'Linux 3.x (i386)',
    /Linux 3\..*x86_64/ => 'Linux 3.x (amd64)',

    /5.1 IX86/ => 'Windows XP (i386)',
    /linux-gnu i686/ => 'Linux x.x (i386)'
  }


class OperatingSystem < ActiveRecord::Base

  has_many :benchmark_configurations, inverse_of: :operating_system


  # Return normalized OS name - suitable for UI
  def name_normalized
    nm = self.name
    OPERATING_SYSTEM_NAME_XLATIONS.each_key do | matcher |
      if matcher.match(nm)
        return OPERATING_SYSTEM_NAME_XLATIONS[matcher]
      end
    end
    return nm
  end
end

# == Schema Information
#
# Table name: operating_systems
#
#  id         :integer          not null, primary key
#  name       :string(255)
#  created_at :datetime
#  updated_at :datetime
#

